Package org.htmlunit.html

# Class HtmlTextArea

java.lang.Object
org.htmlunit.html.DomNode
org.htmlunit.html.DomNamespaceNode
org.htmlunit.html.DomElement
org.htmlunit.html.HtmlElement
org.htmlunit.html.HtmlTextArea

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `DisabledElement`, `FormFieldWithNameHistory`, `org.htmlunit.html.impl.SelectableTextInput`, `LabelableElement`, `SubmittableElement`, `ValidatableElement`, `Element`, `Node`

public class HtmlTextArea extends HtmlElement implements DisabledElement, SubmittableElement, LabelableElement, org.htmlunit.html.impl.SelectableTextInput, FormFieldWithNameHistory, ValidatableElement
Wrapper for the HTML element "textarea".

See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.htmlunit.html.HtmlElement

  `HtmlElement.DisplayStyle`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomElement

  `DomElement.ChildElementsIterator`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomNode

  `DomNode.ChildIterator, DomNode.DescendantDomElementsIterator, DomNode.DescendantDomNodesIterator, DomNode.DescendantElementsIterator<T extends DomNode>, DomNode.DescendantHtmlElementsIterator`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `TAG_NAME`
  The HTML tag represented by this element.

  ### Fields inherited from class org.htmlunit.html.HtmlElement

  `ATTRIBUTE_CHECKED, ATTRIBUTE_HIDDEN, ATTRIBUTE_REQUIRED, TAB_INDEX_OUT_OF_BOUNDS`

  ### Fields inherited from class org.htmlunit.html.DomElement

  `ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY, ID_ATTRIBUTE, NAME_ATTRIBUTE, SRC_ATTRIBUTE, TYPE_ATTRIBUTE, VALUE_ATTRIBUTE`

  ### Fields inherited from class org.htmlunit.html.DomNode

  `PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

  ### Fields inherited from interface org.htmlunit.html.DisabledElement

  `ATTRIBUTE_DISABLED`

  ### Fields inherited from interface org.w3c.dom.Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `acceptChar(char c)`
  Indicates if the provided character can by "typed" in the element.
  `DomNode`
  `cloneNode(boolean deep)`
  `protected void`
  `doType(char c, boolean lastType)`
  Performs the effective type action, called after the keyPress event and before the keyUp event.
  `protected void`
  `doType(int keyCode, boolean lastType)`
  Performs the effective type action, called after the keyPress event and before the keyUp event.
  `void`
  `focus()`
  Sets the focus on this element.
  `final String`
  `getAccessKeyAttribute()`
  Returns the value of the attribute `accesskey`.
  `final String`
  `getColumnsAttribute()`
  Returns the value of the attribute `cols`.
  `HtmlElement.DisplayStyle`
  `getDefaultStyleDisplay()`
  INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
  Returns the default display style.
  `String`
  `getDefaultValue()`
  Returns the default value to use when this element gets reset, if applicable.
  `final String`
  `getDisabledAttribute()`
  Returns the value of the attribute `disabled`.
  `final String`
  `getNameAttribute()`
  Returns the value of the attribute `name`.
  `Collection<String>`
  `getNewNames()`
  Get all the names this field got after the original one.
  `final String`
  `getOnBlurAttribute()`
  Returns the value of the attribute `onblur`.
  `final String`
  `getOnChangeAttribute()`
  Returns the value of the attribute `onchange`.
  `final String`
  `getOnFocusAttribute()`
  Returns the value of the attribute `onfocus`.
  `final String`
  `getOnSelectAttribute()`
  Returns the value of the attribute `onselect`.
  `String`
  `getOriginalName()`
  Gets the first value of the `name` attribute of this field before any change.
  `String`
  `getPlaceholder()`
  Returns the value of the `placeholder` attribute.
  `final String`
  `getReadOnlyAttribute()`
  Returns the value of the attribute `readonly`.
  `final String`
  `getRowsAttribute()`
  Returns the value of the attribute `rows`.
  `String`
  `getSelectedText()`
  Returns the selected text in this element, or `null` if there is no selected text in this element.
  `int`
  `getSelectionEnd()`
  Returns the end position of the selected text in this element.
  `int`
  `getSelectionStart()`
  Returns the start position of the selected text in this element.
  `NameValuePair[]`
  `getSubmitNameValuePairs()`
  Returns an array of `NameValuePair`s that are the values that will be sent back to the server whenever this element's containing form is submitted.
  `final String`
  `getTabIndexAttribute()`
  Returns the value of the attribute `tabindex`.
  `final String`
  `getText()`
  Returns the value that would be displayed in the text area.
  `boolean`
  `handles(org.htmlunit.javascript.host.event.Event event)`
  Indicates if the provided event can be applied to this node.
  `boolean`
  `isCustomErrorValidityState()`
  `boolean`
  `isDefaultChecked()`
  Returns the default checked state to use when this element gets reset, if applicable.
  `final boolean`
  `isDisabled()`
  Returns `true` if the disabled attribute is set for this element.
  `protected boolean`
  `isEmptyXmlTagExpanded()`
  Indicates if a node without children should be written in expanded form as XML (i.e. with closing tag rather than with "/>")
  `boolean`
  `isReadOnly()`
  Returns `true` if this element is read only.
  `protected boolean`
  `isRequiredSupported()`
  Returns whether this element supports the `required` constraint.
  `boolean`
  `isValid()`
  Returns whether this element satisfies all form validation constraints set.
  `boolean`
  `isValidValidityState()`
  `boolean`
  `isValueMissingValidityState()`
  `protected void`
  `printXml(String indent, PrintWriter printWriter)`
  Recursively write the XML data for the node tree starting at `node`.
  `void`
  `removeFocus()`
  INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
  Gets notified that it has lost the focus.
  `void`
  `reset()`
  Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).
  `void`
  `select()`
  Focuses this element and selects all of its text.
  `protected void`
  `setAttributeNS(String namespaceURI, String qualifiedName, String attributeValue, boolean notifyAttributeChangeListeners, boolean notifyMutationObservers)`
  Sets the value of the attribute specified by namespace and qualified name.
  `void`
  `setCustomValidity(String message)`
  Sets the custom validity message for the element to the specified message.
  `void`
  `setDefaultChecked(boolean defaultChecked)`
  Sets the default checked state to use when this element gets reset, if applicable.
  `void`
  `setDefaultValue(String defaultValue)`
  Sets the default value to use when this element gets reset, if applicable.
  `void`
  `setPlaceholder(String placeholder)`
  Sets the `placeholder` attribute.
  `void`
  `setReadOnly(boolean isReadOnly)`
  Sets the `readOnly` attribute.
  `void`
  `setSelectionEnd(int selectionEnd)`
  Sets the end position of the selected text in this element.
  `void`
  `setSelectionStart(int selectionStart)`
  Sets the start position of the selected text in this element.
  `final void`
  `setText(String newValue)`
  Sets the new value of this text area.
  `protected void`
  `typeDone(String newValue, boolean notifyAttributeChangeListeners)`
  Called from `DoTypeProcessor`.
  `boolean`
  `willValidate()`

  ### Methods inherited from class org.htmlunit.html.HtmlElement

  `addHtmlAttributeChangeListener, appendChildIfNoneExists, checkChildHierarchy, detach, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, getCanonicalXPath, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getSrcAttributeNormalized, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, hasEventHandlers, isAltPressed, isAttributeCaseSensitive, isCtrlPressed, isDisplayed, isHidden, isOptional, isRequired, isShiftPressed, isSubmittableByEnter, notifyAttributeChangeListeners, removeAttribute, removeChild, removeHtmlAttributeChangeListener, setAttributeNode, setHidden, setHidden, setOwningForm, setRequired, type, type, type, type`

  ### Methods inherited from class org.htmlunit.html.DomElement

  `blur, click, click, click, click, click, dblClick, dblClick, doClickFireChangeEvent, doClickFireClickEvent, doClickStateUpdate, fireEvent, fireEvent, getAttribute, getAttributeDirect, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getChildElementCount, getChildElements, getElementsByTagName, getElementsByTagNameNS, getEventTargetElement, getFirstElementChild, getId, getLastElementChild, getNodeType, getSchemaTypeInfo, getStaticElementsByTagName, getStyleElement, getStyleElementCaseInSensitive, getStyleMap, getTagName, hasAttribute, hasAttributeNS, hasAttributes, isDisabledElementAndDisabled, isMouseOver, isStateUpdateFirst, matches, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, preventDefault, printOpeningTagContentAsXml, propagateClickStateUpdateToParent, removeAttributeNode, removeAttributeNS, removeStyleAttribute, replaceStyleAttribute, rightClick, rightClick, setAttribute, setAttributeNodeNS, setAttributeNS, setDefaults, setId, setIdAttribute, setIdAttributeNode, setIdAttributeNS, setInnerHtml, setNodeValue, toString, writeStyleToElement`

  ### Methods inherited from class org.htmlunit.html.DomNamespaceNode

  `getLocalName, getLowercaseName, getNamespaceURI, getPrefix, getQualifiedName, processImportNode, setPrefix`

  ### Methods inherited from class org.htmlunit.html.DomNode

  `addCharacterDataChangeListener, addDomChangeListener, appendChild, asNormalizedText, asXml, basicRemove, closest, compareDocumentPosition, fireCharacterDataChanged, fireNodeAdded, fireNodeDeleted, getAncestors, getBaseURI, getByXPath, getByXPath, getChildNodes, getChildren, getDescendants, getDomElementDescendants, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstByXPath, getFirstChild, getHtmlElementDescendants, getHtmlPageOrNull, getIndex, getLastChild, getNextElementSibling, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousElementSibling, getPreviousSibling, getReadyState, getScriptableObject, getSelectorList, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, getVisibleText, hasChildNodes, hasFeature, insertBefore, insertBefore, isAncestorOf, isAncestorOfAny, isAttachedToPage, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, mayBeDisplayed, normalize, notifyIncorrectness, onAddedToDocumentFragment, onAddedToPage, onAllChildrenAddedToPage, parseHtmlSnippet, printChildrenAsXml, querySelector, querySelectorAll, quietlyRemoveAndMoveChildrenTo, remove, removeAllChildren, removeCharacterDataChangeListener, removeChild, removeDomChangeListener, replace, replaceChild, setEndLocation, setParentNode, setReadyState, setScriptableObject, setStartLocation, setTextContent, setUserData`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.w3c.dom.Node

  `appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setPrefix, setTextContent, setUserData`

  ### Methods inherited from interface org.htmlunit.html.impl.SelectableTextInput

  `getPage`

  ### Methods inherited from interface org.htmlunit.html.ValidatableElement

  `hasBadInputValidityState, hasPatternMismatchValidityState, hasRangeOverflowValidityState, hasRangeUnderflowValidityState, hasTypeMismatchValidityState, isStepMismatchValidityState, isTooLongValidityState, isTooShortValidityState`

- ## Field Details

  - ### TAG_NAME

    public static final String TAG_NAME
    The HTML tag represented by this element.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### handles

    public boolean handles(org.htmlunit.javascript.host.event.Event event)
    Indicates if the provided event can be applied to this node. Overwrite this.
    Overrides:
      `handles` in class `HtmlElement`
    Parameters:
      `event` - the event
    Returns:
      `false` if the event can't be applied

  - ### getText

    public final String getText()
    Returns the value that would be displayed in the text area.
    Specified by:
      `getText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the text

  - ### setText

    public final void setText(String newValue)
    Sets the new value of this text area.

    Note that this acts like 'pasting' the text, but to simulate characters entry you should use `HtmlElement.type(String)`.

    Specified by:
      `setText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `newValue` - the new value

  - ### getSubmitNameValuePairs

    public NameValuePair[] getSubmitNameValuePairs()

    Returns an array of `NameValuePair`s that are the values that will be sent back to the server whenever this element's containing form is submitted.

    THIS METHOD IS INTENDED FOR THE USE OF THE FRAMEWORK ONLY AND SHOULD NOT BE USED BY CONSUMERS OF HTMLUNIT. USE AT YOUR OWN RISK.

    Specified by:
      `getSubmitNameValuePairs` in interface `SubmittableElement`
    Returns:
      the values that will be sent back to the server whenever this element's containing form is submitted

  - ### reset

    public void reset()
    Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).
    Specified by:
      `reset` in interface `SubmittableElement`
    See Also:
      - `SubmittableElement.reset()`

  - ### setDefaultValue

    public void setDefaultValue(String defaultValue)
    Sets the default value to use when this element gets reset, if applicable.
    Specified by:
      `setDefaultValue` in interface `SubmittableElement`
    Parameters:
      `defaultValue` - the default value to use when this element gets reset, if applicable
    See Also:
      - `SubmittableElement.setDefaultValue(String)`

  - ### getDefaultValue

    public String getDefaultValue()
    Returns the default value to use when this element gets reset, if applicable.
    Specified by:
      `getDefaultValue` in interface `SubmittableElement`
    Returns:
      the default value to use when this element gets reset, if applicable
    See Also:
      - `SubmittableElement.getDefaultValue()`

  - ### setDefaultChecked

    public void setDefaultChecked(boolean defaultChecked)
    Sets the default checked state to use when this element gets reset, if applicable. The default implementation is empty; only checkboxes and radio buttons really care what the default checked value is. This implementation is empty; only checkboxes and radio buttons really care what the default checked value is.
    Specified by:
      `setDefaultChecked` in interface `SubmittableElement`
    Parameters:
      `defaultChecked` - the default checked state to use when this element gets reset, if applicable
    See Also:
      - `SubmittableElement.setDefaultChecked(boolean)`
      - `HtmlRadioButtonInput.setDefaultChecked(boolean)`
      - `HtmlCheckBoxInput.setDefaultChecked(boolean)`

  - ### isDefaultChecked

    public boolean isDefaultChecked()
    Returns the default checked state to use when this element gets reset, if applicable. This implementation returns `false`; only checkboxes and radio buttons really care what the default checked value is.
    Specified by:
      `isDefaultChecked` in interface `SubmittableElement`
    Returns:
      the default checked state to use when this element gets reset, if applicable
    See Also:
      - `SubmittableElement.isDefaultChecked()`
      - `HtmlRadioButtonInput.isDefaultChecked()`
      - `HtmlCheckBoxInput.isDefaultChecked()`

  - ### getNameAttribute

    public final String getNameAttribute()
    Returns the value of the attribute `name`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `name` or an empty string if that attribute isn't defined

  - ### getRowsAttribute

    public final String getRowsAttribute()
    Returns the value of the attribute `rows`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `rows` or an empty string if that attribute isn't defined

  - ### getColumnsAttribute

    public final String getColumnsAttribute()
    Returns the value of the attribute `cols`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `cols` or an empty string if that attribute isn't defined

  - ### isDisabled

    public final boolean isDisabled()
    Returns `true` if the disabled attribute is set for this element.
    Specified by:
      `isDisabled` in interface `DisabledElement`
    Returns:
      `true` if the disabled attribute is set for this element

  - ### getDisabledAttribute

    public final String getDisabledAttribute()
    Returns the value of the attribute `disabled`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Specified by:
      `getDisabledAttribute` in interface `DisabledElement`
    Returns:
      the value of the attribute `disabled` or an empty string if that attribute isn't defined

  - ### getReadOnlyAttribute

    public final String getReadOnlyAttribute()
    Returns the value of the attribute `readonly`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `readonly` or an empty string if that attribute isn't defined

  - ### getTabIndexAttribute

    public final String getTabIndexAttribute()
    Returns the value of the attribute `tabindex`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `tabindex` or an empty string if that attribute isn't defined

  - ### getAccessKeyAttribute

    public final String getAccessKeyAttribute()
    Returns the value of the attribute `accesskey`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `accesskey` or an empty string if that attribute isn't defined

  - ### getOnFocusAttribute

    public final String getOnFocusAttribute()
    Returns the value of the attribute `onfocus`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `onfocus` or an empty string if that attribute isn't defined

  - ### getOnBlurAttribute

    public final String getOnBlurAttribute()
    Returns the value of the attribute `onblur`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `onblur` or an empty string if that attribute isn't defined

  - ### getOnSelectAttribute

    public final String getOnSelectAttribute()
    Returns the value of the attribute `onselect`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `onselect` or an empty string if that attribute isn't defined

  - ### getOnChangeAttribute

    public final String getOnChangeAttribute()
    Returns the value of the attribute `onchange`. Refer to the HTML 4.01 documentation for details on the use of this attribute.
    Returns:
      the value of the attribute `onchange` or an empty string if that attribute isn't defined

  - ### select

    public void select()
    Focuses this element and selects all of its text.
    Specified by:
      `select` in interface `org.htmlunit.html.impl.SelectableTextInput`

  - ### getSelectedText

    public String getSelectedText()
    Returns the selected text in this element, or `null` if there is no selected text in this element.
    Specified by:
      `getSelectedText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the selected text in this element, or `null` if there is no selected text in this element

  - ### getSelectionStart

    public int getSelectionStart()
    Returns the start position of the selected text in this element.
    Specified by:
      `getSelectionStart` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the start position of the selected text in this element

  - ### setSelectionStart

    public void setSelectionStart(int selectionStart)
    Sets the start position of the selected text in this element.
    Specified by:
      `setSelectionStart` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `selectionStart` - the start position of the selected text in this element

  - ### getSelectionEnd

    public int getSelectionEnd()
    Returns the end position of the selected text in this element.
    Specified by:
      `getSelectionEnd` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the end position of the selected text in this element

  - ### setSelectionEnd

    public void setSelectionEnd(int selectionEnd)
    Sets the end position of the selected text in this element.
    Specified by:
      `setSelectionEnd` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `selectionEnd` - the end position of the selected text in this element

  - ### printXml

    protected void printXml(String indent, PrintWriter printWriter)
    Recursively write the XML data for the node tree starting at `node`.
    Overrides:
      `printXml` in class `DomElement`
    Parameters:
      `indent` - white space to indent child nodes
      `printWriter` - writer where child nodes are written

  - ### doType

    protected void doType(char c, boolean lastType)
    Performs the effective type action, called after the keyPress event and before the keyUp event.
    Overrides:
      `doType` in class `HtmlElement`
    Parameters:
      `c` - the character you with to simulate typing
      `lastType` - is this the last character to type

  - ### doType

    protected void doType(int keyCode, boolean lastType)
    Performs the effective type action, called after the keyPress event and before the keyUp event.

    An example of predefined values is `KeyboardEvent.DOM_VK_PAGE_DOWN`.

    Overrides:
      `doType` in class `HtmlElement`
    Parameters:
      `keyCode` - the key code wish to simulate typing
      `lastType` - is this the last to type

  - ### typeDone

    protected void typeDone(String newValue, boolean notifyAttributeChangeListeners)
    Called from `DoTypeProcessor`.
    Overrides:
      `typeDone` in class `HtmlElement`
    Parameters:
      `newValue` - the new value
      `notifyAttributeChangeListeners` - to notify the associated `HtmlAttributeChangeListener`s

  - ### acceptChar

    protected boolean acceptChar(char c)
    Indicates if the provided character can by "typed" in the element.
    Overrides:
      `acceptChar` in class `HtmlElement`
    Parameters:
      `c` - the character
    Returns:
      `true` if it is accepted

  - ### focus

    public void focus()
    Sets the focus on this element.
    Specified by:
      `focus` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Overrides:
      `focus` in class `DomElement`

  - ### removeFocus

    public void removeFocus()
    INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
    Gets notified that it has lost the focus.
    Overrides:
      `removeFocus` in class `DomElement`

  - ### setReadOnly

    public void setReadOnly(boolean isReadOnly)
    Sets the `readOnly` attribute.
    Parameters:
      `isReadOnly` - `true` if this element is read only

  - ### isReadOnly

    public boolean isReadOnly()
    Returns `true` if this element is read only.
    Returns:
      `true` if this element is read only

  - ### setAttributeNS

    protected void setAttributeNS(String namespaceURI, String qualifiedName, String attributeValue, boolean notifyAttributeChangeListeners, boolean notifyMutationObservers)
    Sets the value of the attribute specified by namespace and qualified name.
    Overrides:
      `setAttributeNS` in class `HtmlElement`
    Parameters:
      `namespaceURI` - the URI that identifies an XML namespace
      `qualifiedName` - the qualified name (prefix:local) of the attribute
      `attributeValue` - the value of the attribute
      `notifyAttributeChangeListeners` - to notify the associated `HtmlAttributeChangeListener`s
      `notifyMutationObservers` - to notify `MutationObserver`s or not

  - ### getOriginalName

    public String getOriginalName()
    Gets the first value of the `name` attribute of this field before any change.
    Specified by:
      `getOriginalName` in interface `FormFieldWithNameHistory`
    Returns:
      the original name (which is the same as the current one when no change has been made)

  - ### getNewNames

    public Collection<String> getNewNames()
    Get all the names this field got after the original one.
    Specified by:
      `getNewNames` in interface `FormFieldWithNameHistory`
    Returns:
      an empty collection if the name attribute has never been changed.

  - ### isEmptyXmlTagExpanded

    protected boolean isEmptyXmlTagExpanded()
    Indicates if a node without children should be written in expanded form as XML (i.e. with closing tag rather than with "/>")
    Overrides:
      `isEmptyXmlTagExpanded` in class `DomElement`
    Returns:
      `true` to make generated XML readable as HTML

  - ### getDefaultStyleDisplay

    public HtmlElement.DisplayStyle getDefaultStyleDisplay()
    INTERNAL API - SUBJECT TO CHANGE AT ANY TIME - USE AT YOUR OWN RISK.
    Returns the default display style.
    Overrides:
      `getDefaultStyleDisplay` in class `HtmlElement`
    Returns:
      the default display style

  - ### getPlaceholder

    public String getPlaceholder()
    Returns the value of the `placeholder` attribute.
    Returns:
      the value of the `placeholder` attribute

  - ### setPlaceholder

    public void setPlaceholder(String placeholder)
    Sets the `placeholder` attribute.
    Parameters:
      `placeholder` - the `placeholder` attribute

  - ### isRequiredSupported

    protected boolean isRequiredSupported()
    Returns whether this element supports the `required` constraint.
    Overrides:
      `isRequiredSupported` in class `HtmlElement`
    Returns:
      whether this element supports the `required` constraint

  - ### cloneNode

    public DomNode cloneNode(boolean deep)
    Specified by:
      `cloneNode` in interface `Node`
    Overrides:
      `cloneNode` in class `HtmlElement`

  - ### willValidate

    public boolean willValidate()
    Specified by:
      `willValidate` in interface `ValidatableElement`
    Returns:
      whether the element is a candidate for constraint validation

  - ### setCustomValidity

    public void setCustomValidity(String message)
    Sets the custom validity message for the element to the specified message.
    Specified by:
      `setCustomValidity` in interface `ValidatableElement`
    Parameters:
      `message` - the new message

  - ### isValid

    public boolean isValid()
    Returns whether this element satisfies all form validation constraints set.
    Overrides:
      `isValid` in class `HtmlElement`
    Returns:
      whether this element satisfies all form validation constraints set

  - ### isCustomErrorValidityState

    public boolean isCustomErrorValidityState()
    Specified by:
      `isCustomErrorValidityState` in interface `ValidatableElement`
    Returns:
      a boolean value indicating whether the element's custom validity message has been set to a non-empty string by calling the element's setCustomValidity() method.

  - ### isValidValidityState

    public boolean isValidValidityState()
    Specified by:
      `isValidValidityState` in interface `ValidatableElement`
    Returns:
      true if the element meets all its validation constraints, and is therefore considered to be valid, or false if it fails any constraint. If true, the element matches the :valid CSS pseudo-class; the :invalid CSS pseudo-class otherwise.

  - ### isValueMissingValidityState

    public boolean isValueMissingValidityState()
    Specified by:
      `isValueMissingValidityState` in interface `ValidatableElement`
    Returns:
      true if the element has a required attribute, but no value, or false otherwise. If true, the element matches the :invalid CSS pseudo-class.